Set Implicit Arguments.

Module Type PRIMITIVES.

  Section Processors.

    Parameter bsp_p : nat.

    Axiom bsp_pNotZero: 0 < bsp_p.
    
    Definition processor := { pid: nat | pid < bsp_p }.

  End Processors.
    
  Section Parallel_vectors.

    Parameter par : Type -> Type.

    Parameter get : forall A: Type, par A -> processor -> A.

    Parameter par_eq : forall (A:Type) (v v': par A),
      (forall (i: processor), get v i = get v' i) -> v = v'.

  End Parallel_vectors.

  Section Primitives.

    Variable A : Type.

    Parameter mkpar: 
      forall f: processor -> A,
        { X: par A | forall i: processor, get X i = f i }.

    Parameter apply: 
      forall (B: Type) (vf: par (forall a:A, B)) (vx: par A),
        { X: par B | forall i: processor, 
          get X i = (get vf i) (get vx i) }.

    Parameter put: 
      forall (vf: par (processor -> A)),
        { X: par (processor -> A) | 
          forall i j: processor, get X i j = get vf j i }.
    
    Parameter proj: 
      forall (v: par A),
        { X: processor -> A | forall i: processor, X i = get v i }.

  End Primitives.

End PRIMITIVES.